package schl

import (
	"context"
	"github.com/gogf/gf/encoding/gjson"
	"github.com/gogf/gf/frame/g"
)

type GoodsEventRes struct {
	CommonRes
	Result []struct {
		EventKey       string `json:"eventKey"`
		EventDesc      string `json:"eventDesc"`
		ChangesContent []struct {
			Code  string `json:"code,omitempty"`
			Price string `json:"price,omitempty"`
			Id    string `json:"id,omitempty"`
			State string `json:"state,omitempty"`
		} `json:"changesContent"`
	} `json:"result"`
}

func (*goodsLogic) Event(ctx context.Context) (res *GoodsEventRes, err error) {

	result, err := server.Post(ctx, "/open/xdxt/api/v2/goods/listGoodsChangeEvent", g.Map{})
	if err != nil {
		return
	}

	err = gjson.New(result).Scan(&res)
	return
}
