package schl

import (
	"context"
	"github.com/gogf/gf/encoding/gjson"
	"github.com/gogf/gf/util/gconv"
)

type OrderBeforeReq struct {
	FreightPayer     int    `json:"freightPayer"`
	InvoiceHeaderId  int    `json:"invoiceHeaderId"`
	InvoiceType      int    `json:"invoiceType"`
	Province         string `json:"province"`
	City             string `json:"city"`
	District         string `json:"district"`
	ExpCode          string `json:"expCode"`
	OrderDetailsList []struct {
		Code string `json:"code"`
		Num  int    `json:"num"`
	} `json:"orderDetailsList"`
}

type OrderBeforeRes struct {
	Code   int    `json:"code"`
	Msg    string `json:"msg"`
	Result struct {
		Freight          float64 `json:"freight"`
		GoodsMoneyAmount float64 `json:"goodsMoneyAmount"`
		PayMoney         float64 `json:"payMoney"`
	} `json:"result"`
	TraceId string `json:"traceId"`
}

// Before 订单运费
func (s *orderLogic) Before(ctx context.Context, req OrderBeforeReq) (res *OrderBeforeRes, err error) {

	result, err := server.Post(ctx, "/open/xdxt/api/v2/order/orderFreightPreview", gconv.Map(req))
	if err != nil {
		return
	}

	err = gjson.New(result).Scan(&res)
	return
}
